PNCR-I(贪心+斜率优化)

题目链接

https://codeforces.com/gym/101982/

题意

给定一段长度为 $n (n\le2e5)$ 的序列,其中有一些数还没填,你要把数列填完,使得逆序对数最大,输出逆序对数。每个数的范围为 $1\sim m(m\le100)$

题解

不造如何描述题目来源= =

这个题目还是比较经典的,值得做做。。

首先感觉填进去的序列应该是大致递减的,那么如果有增的情况会如何?

设 $i<j​$ 且 $a[i]<a[j]​$ ,那么如果交换 $a[i]​$ 、$a[j]​$ ,显然逆序对会增加,所以可以确定填进去的序列是非递增的

那么可以先预处理第 $i​$ 个数填 $j​$ 产生的价值,设为 $a[i][j]​$ ,并求前缀和

就可以做$DP​$ 了,设 $d[i][j]​$ 为 第 $i​$ 个空填 $j​$ 的最大逆序对数,那么

这个显然可以斜率优化,然后复杂度就可以降到 $O(nm)​$

注意这个式子对 $j=m$ 并不成立 TAT ,WA了半天




代码

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
/**
*         ┏┓    ┏┓
*         ┏┛┗━━━━━━━┛┗━━━┓
*         ┃       ┃  
*         ┃   ━    ┃
*         ┃ >   < ┃
*         ┃       ┃
*         ┃... ⌒ ...  ┃
*         ┃ ┃
*         ┗━┓ ┏━┛
*          ┃ ┃ Code is far away from bug with the animal protecting          
*          ┃ ┃ 神兽保佑,代码无bug
*          ┃ ┃           
*          ┃ ┃       
*          ┃ ┃
*          ┃ ┃           
*          ┃ ┗━━━┓
*          ┃ ┣┓
*          ┃ ┏┛
*          ┗┓┓┏━━━━━━━━┳┓┏┛
*           ┃┫┫ ┃┫┫
*           ┗┻┛ ┗┻┛
*/

#include<cstdio>
#include<cstring>
#include<algorithm>
#include<iostream>
#include<queue>
#include<map>
#include<stack>
#include<cmath>
#include<set>
#include<bitset>
#include<assert.h>
#define inc(i,l,r) for(int i=l;i<=r;i++)
#define dec(i,l,r) for(int i=l;i>=r;i--)
#define link(x) for(edge *j=h[x];j;j=j->next)
#define mem(a) memset(a,0,sizeof(a))
#define ll long long
#define eps 1e-8
#define succ(x) (1<<x)
#define lowbit(x) (x&(-x))
#define sqr(x) ((x)*(x))
#define mid (x+y)/2
#define NM 200005
#define nm 105
#define pi 3.1415926535897931
using namespace std;
const ll inf=1e18;
ll read(){
ll x=0,f=1;char ch=getchar();
while(!isdigit(ch)){if(ch=='-')f=-1;ch=getchar();}
while(isdigit(ch))x=x*10+ch-'0',ch=getchar();
return f*x;
}




int n,m,q[NM],qh,qt,tot,_x,a[NM][nm],c[NM][nm];
ll d[NM],g[NM],ans,b[NM],s;
double slope(int x,int y){return 1.0*(g[x]-b[x]-g[y]+b[y])/(y-x)+x+y;}

int main(){
//freopen("data.in","r",stdin);
n=read();m=read();
while(n--){
_x=read();
if(_x){
ans+=b[_x];
dec(i,_x-1,1)b[i]++;
c[tot][_x+1]++;
}else{
tot++;
inc(i,1,m)a[tot][i]=b[i];
}
}
n=tot;
dec(i,n,1){
inc(j,1,m)c[i][j]+=c[i][j-1];
inc(j,1,m)c[i][j]+=c[i+1][j],a[i][j]+=c[i][j];
}
inc(i,1,n)g[i]=a[i][m]+g[i-1];
dec(j,m-1,1){
q[qh=qt=1]=0;
inc(i,1,n)b[i]=b[i-1]+a[i][j];
inc(i,1,n){
while(qh<qt&&slope(q[qh],q[qh+1])<i)qh++;
d[i]=g[q[qh]]+1ll*(i-q[qh])*q[qh]+b[i]-b[q[qh]];
while(qh<qt&&slope(q[qt-1],q[qt])>slope(q[qt],i))qt--;
q[++qt]=i;
}
inc(i,1,n)g[i]=max(g[i],d[i]),s=max(s,g[i]);
// inc(i,1,n)printf("%lld ",g[i]);putchar('\n');
}
printf("%lld\n",s+ans);
return 0;
}